unit Display;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Vfw, Buttons, StdCtrls, AppEvnts;

type
  TDisplayForm = class(TForm)
    StartTimer: TTimer;
    StatusLabel: TLabel;
    AppEv: TApplicationEvents;
    procedure StartTimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DisplayForm: TDisplayForm;
  CapHWnd: THandle;
  capPreviewing: Boolean;

implementation

{$R *.DFM}

procedure TDisplayForm.StartTimerTimer(Sender: TObject);
begin
  StartTimer.Enabled := False;
  StatusLabel.Caption := 'Voorbereiden verbinding...';
  StatusLabel.Repaint;
  CapHWnd :=
    capCreateCaptureWindow('FullScreen CamView',
    WS_CHILD,0,0,ClientWidth,ClientHeight,
    Self.Handle,0);
  If CapHWnd = 0 then begin
    Close;
    Exit;
  end;
  StatusLabel.Caption := 'Verbinding maken met webcam...';
  StatusLabel.Repaint;
  If capDriverConnect(CapHWnd,0) then begin
    capPreviewScale(CapHWnd, True);
    capPreviewRate(CapHWnd, 33); // 30 fps
    capPreviewing := capPreview(CapHWnd, True);
    ShowWindow(CapHWnd,SW_SHOW);
  end else begin
    ShowCursor(True);
    StatusLabel.Caption := 'Fout!';
    StatusLabel.Repaint;
    ShowMessage('Helaas... er is geen verbinding mogelijk met een capture apparaat');
    Close;
  end;
end;

procedure TDisplayForm.FormCreate(Sender: TObject);
begin
  ShowCursor(False);
end;

procedure TDisplayForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ShowCursor(True);
end;

procedure TDisplayForm.FormActivate(Sender: TObject);
begin
  capPreviewRate(CapHWnd, 33);   // 20 fps
end;

procedure TDisplayForm.FormDeactivate(Sender: TObject);
begin
  capPreviewRate(CapHWnd, 1000); // 1 fps
end;

procedure TDisplayForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Case Key of

    27: // Escape (quit)
    begin
      Close;
    end;

    32: // Space (pause)
    begin
      If capPreview(CapHWnd, not capPreviewing) then
        capPreviewing := not capPreviewing;
    end;

    // Ctrl + F(ormat)

    // Ctrl + D(isplay)

    // Ctrl + S(ource)

    // F1 (help)

  end;
end;

initialization
  capPreviewing := False;

end.
